#!/usr/bin/env bash

# input/output paths
idir="/scratch/users/sbusi/ONT/mock/reference_genomes"
odir="/scratch/users/vgalata/Zymo/mash_screen_test"
mkdir -p "${odir}"

# reference
ref="${odir}/ref.fna"
cat "${idir}/eukaryotes.fna" "${idir}/prokaryotes.fna" > "${ref}"

# assembly
asm="${odir}/flye.fna"
ln -sf $(realpath "${idir}/flye.fna") "${odir}/flye.fna"

# mash analysis
# conda: Mash version 2.2.2
conda activate /home/users/vgalata/miniconda3/envs/ONT_pilot/pipeline/d8ed275a
# mash sketch references
mash sketch -p 3 -k 31 -s 1000 -S 42 -i -o "${ref}" "${ref}"
mash sketch -p 3 -k 31 -s 1000 -S 42 -i -o "${asm}" "${asm}"
# mash screen
mash screen -p 3 -i -1 "${ref}.msh" "${asm}" > "${odir}/mash_screen_ref_flye.tsv"
mash screen -p 3 -i -1 "${asm}.msh" "${ref}" > "${odir}/mash_screen_flye_ref.tsv"
# XXX
cut -f2,5 "${odir}/mash_screen_flye_ref.tsv" | sed "s@/@\t@" | sort -n -k1,1 | head -n 10 > "${odir}/mash_screen_flye_ref.top10.txt"
