# Assembly

include:
    "../rules/analysis.smk"

rule ANALYSIS:
    input:
        # quast
        expand(
            os.path.join(RESULTS_DIR, "analysis/quast/{rtype_tool}/report.tsv"),
            rtype_tool=["%s/%s" % (rtype, tool) for rtype, tool in READ_ASSEMBLERS]
        ) if "quast" in config["steps_analysis"] else [],
        # mashmap
        expand(
            os.path.join(RESULTS_DIR, "analysis/mashmap/{combi}.one2one.out"),
            combi=["%s_%s__%s_%s" % (p[0][0], p[0][1], p[1][0], p[1][1]) for p in READ_ASSEMBLER_PAIRS] +
            ["%s_%s__%s_%s" % (p[1][0], p[1][1], p[0][0], p[0][1]) for p in READ_ASSEMBLER_PAIRS]
        ) if "mashmap" in config["steps_analysis"] else [],
        # fastani
        os.path.join(RESULTS_DIR, "analysis/fastani/many2many.out"),
        # mummer
        expand(
            os.path.join(RESULTS_DIR, "analysis/mummer/{combi}.dnadiff.report"),
            combi=["%s_%s__%s_%s" % (p[0][0], p[0][1], p[1][0], p[1][1]) for p in READ_ASSEMBLER_PAIRS] +
            ["%s_%s__%s_%s" % (p[1][0], p[1][1], p[0][0], p[0][1]) for p in READ_ASSEMBLER_PAIRS]
        ) if "mummer" in config["steps_analysis"] else [],
        # cdhit
        expand(
            os.path.join(RESULTS_DIR, "analysis/cdhit/{combi}.faa"),
            combi=["%s_%s__%s_%s" % (p[0][0], p[0][1], p[1][0], p[1][1]) for p in READ_ASSEMBLER_PAIRS] +
            ["%s_%s__%s_%s" % (p[1][0], p[1][1], p[0][0], p[0][1]) for p in READ_ASSEMBLER_PAIRS]
        ) if "cdhit" in config["steps_analysis"] else [],
        # diamond
        expand(
            os.path.join(RESULTS_DIR, "annotation/diamond/{rtype_tool}/proteins.{ext}"),
            rtype_tool=["%s/%s" % (rtype, tool) for rtype, tool in READ_ASSEMBLERS],
            ext=["daa", "tsv"]
        ) if "diamond" in config["steps_analysis"] else [],
        expand(
            os.path.join(RESULTS_DIR, "analysis/diamond/{combi}.tsv"),
            combi=["%s_%s__%s_%s" % (p[0][0], p[0][1], p[1][0], p[1][1]) for p in READ_ASSEMBLER_PAIRS] +
            ["%s_%s__%s_%s" % (p[1][0], p[1][1], p[0][0], p[0][1]) for p in READ_ASSEMBLER_PAIRS]
        ) if "cdhit" in config["steps_analysis"] else [],
        # mash
        expand(
            os.path.join(RESULTS_DIR, "analysis/mash/{dtype}.dist"),
            dtype=["contigs", "reads"]
        ) if "mash" in config["steps_analysis"] else [],
    output:
        touch("status/analysis.done")
